Whamcloud - gitweb
LU-2730 mdt: fix erroneous LASSERT in mdt_reint_opcode
[fs/lustre-release.git] / lustre / scripts / lfs_migrate
1 #!/bin/bash
2 # set -x
3 set -e
4
5 # lfs_migrate: a simple tool to copy and check files.
6 #
7 # To avoid allocating objects on one or more OSTs, they should be
8 # deactivated on the MDS via "lctl --device {device_number} deactivate",
9 # where {device_number} is from the output of "lctl dl" on the MDS.
10 #
11 # To guard against corruption, the file is compared after migration
12 # to verify the copy is correct and the file has not been modified.
13 # This is not a protection against the file being open by another
14 # process, but it would catch the worst cases of in-use files, but
15 # to be 100% safe the administrator needs to ensure this is safe.
16
17 RSYNC=${RSYNC:-rsync}
18 ECHO=echo
19 LFS=${LFS:-lfs}
20 LFS_SIZE_OPT="-s"
21
22 usage() {
23     cat -- <<USAGE 1>&2
24 usage: lfs_migrate [-c <stripe_count>] [-h] [-l] [-n] [-q] [-R] [-s] [-y] [-0]
25                    [file|dir ...]
26     -c <stripe_count>
27        restripe file using the specified stripe count
28     -h show this usage message
29     -l migrate files with hard links (skip by default)
30     -n only print the names of files to be migrated
31     -q run quietly (don't print filenames or status)
32     -R restripe file using default directory striping
33     -s skip file data comparison after migrate
34     -y answer 'y' to usage question
35     -0 input file names on stdin are separated by a null character
36
37 The -c <stripe_count> option may not be specified at the same time as
38 the -R option.
39
40 If a directory is an argument, all files in the directory are migrated.
41 If no file/directory is given, the file list is read from standard input.
42
43 e.g.: lfs_migrate /mnt/lustre/dir
44       lfs find /test -O test-OST0004 -size +4G | lfs_migrate -y
45 USAGE
46     exit 1
47 }
48
49 OPT_CHECK=y
50 OPT_STRIPE_COUNT=""
51
52 while getopts "c:hlnqRsy0" opt $*; do
53     case $opt in
54         c) OPT_STRIPE_COUNT=$OPTARG;;
55         l) OPT_NLINK=y;;
56         n) OPT_DRYRUN=n; OPT_YES=y;;
57         q) ECHO=:;;
58         R) OPT_RESTRIPE=y;;
59         s) OPT_CHECK="";;
60         y) OPT_YES=y;;
61         0) OPT_NULL=y;;
62         h|\?) usage;;
63     esac
64 done
65 shift $((OPTIND - 1))
66
67 if [ "$OPT_STRIPE_COUNT" -a "$OPT_RESTRIPE" ]; then
68         echo ""
69         echo "$(basename $0) error: The -c <stripe_count> option may not" 1>&2
70         echo "be specified at the same time as the -R option." 1>&2
71         exit 1
72 fi
73
74 if [ -z "$OPT_YES" ]; then
75         echo ""
76         echo "lfs_migrate is currently NOT SAFE for moving in-use files." 1>&2
77         echo "Use it only when you are sure migrated files are unused." 1>&2
78         echo "" 1>&2
79         echo "If emptying OST(s) that are not disabled on the MDS, new" 1>&2
80         echo "files may use them.  To prevent MDS allocating any files on" 1>&2
81         echo "OSTNNNN run 'lctl --device %{fsname}-OSTNNNN-osc deactivate'" 1>&2
82         echo "on the MDS." 1>&2
83         echo -n "Continue? (y/n) "
84         read CHECK
85         [ "$CHECK" != "y" -a "$CHECK" != "yes" ] && exit 1
86 fi
87
88 # if rsync has --xattr support, then try to copy the xattrs.
89 $RSYNC --help 2>&1 | grep -q xattr && RSYNC_OPTS="$RSYNC_OPTS -X"
90 $RSYNC --help 2>&1 | grep -q acls && RSYNC_OPTS="$RSYNC_OPTS -A"
91 # If rsync copies lustre xattrs in the future, then we can skip lfs (bug 22189)
92 strings $(which $RSYNC) 2>&1 | grep -q lustre && LFS=:
93
94 # rsync creates its temporary files with lenient permissions, even if
95 # permissions on the original files are more strict. Tighten umask here
96 # to avoid the brief window where unprivileged users might be able to
97 # access the temporary file.
98 umask 0077
99
100 # This is needed for 1.8 Interoperability and can be removed in the future
101 $LFS getstripe --help 2>&1 | grep -q stripe-size && LFS_SIZE_OPT="-S"
102
103 lfs_migrate() {
104         while IFS='' read -d '' OLDNAME; do
105                 $ECHO -n "$OLDNAME: "
106
107                 # avoid duplicate stat if possible
108                 TYPE_LINK=($(LANG=C stat -c "%h %F" "$OLDNAME" || true))
109
110                 # skip non-regular files, since they don't have any objects
111                 # and there is no point in trying to migrate them.
112                 if [ "${TYPE_LINK[1]}" != "regular" ]; then
113                         echo -e "not a regular file, skipped"
114                         continue
115                 fi
116
117                 if [ -z "$OPT_NLINK" -a ${TYPE_LINK[0]} -gt 1 ]; then
118                         echo -e "multiple hard links, skipped"
119                         continue
120                 fi
121
122                 # working out write perms is hard, let the shell do it
123                 if [ ! -w "$OLDNAME" ]; then
124                         echo -e "no write permission, skipped"
125                         continue
126                 fi
127
128                 if [ "$OPT_DRYRUN" ]; then
129                         echo -e "dry run, skipped"
130                         continue
131                 fi
132
133
134                 if [ "$OPT_RESTRIPE" ]; then
135                         UNLINK=""
136                 else
137                 # if rsync copies Lustre xattrs properly in the future
138                 # (i.e. before the file data, so that it preserves striping)
139                 # then we don't need to do this getstripe/mktemp stuff.
140                         UNLINK="-u"
141
142                         [ "$OPT_STRIPE_COUNT" ] && COUNT=$OPT_STRIPE_COUNT ||
143                                 COUNT=$($LFS getstripe -c "$OLDNAME" \
144                                         2> /dev/null)
145                         SIZE=$($LFS getstripe $LFS_SIZE_OPT "$OLDNAME" \
146                                2> /dev/null)
147
148                         [ -z "$COUNT" -o -z "$SIZE" ] && UNLINK=""
149                 fi
150                 NEWNAME=$(mktemp $UNLINK "$OLDNAME.tmp.XXXXXX")
151                 if [ $? -ne 0 -o -z "$NEWNAME" ]; then
152                         echo -e "\r$OLDNAME: can't make temp file, skipped" 1>&2
153                         continue
154                 fi
155
156                 [ "$UNLINK" ] && $LFS setstripe -c${COUNT} \
157                                       ${LFS_SIZE_OPT}${SIZE} "$NEWNAME"
158
159                 # we use --inplace, since we created our own temp file already
160                 if ! $RSYNC -a --inplace $RSYNC_OPTS "$OLDNAME" "$NEWNAME";then
161                         echo -e "\r$OLDNAME: copy error, exiting" 1>&2
162                         rm -f "$NEWNAME"
163                         exit 4
164                 fi
165
166                 if [ "$OPT_CHECK" ] && ! cmp "$OLDNAME" "$NEWNAME"; then
167                         echo -e "\r$NEWNAME: compare failed, exiting" 1>&2
168                         exit 8
169                 fi
170
171                 if ! mv "$NEWNAME" "$OLDNAME"; then
172                         echo -e "\r$OLDNAME: rename error, exiting" 1>&2
173                         exit 12
174                 fi
175                 $ECHO "done"
176         done
177 }
178
179 if [ "$#" -eq 0 ]; then
180         if [ "$OPT_NULL" ]; then
181                 lfs_migrate
182         else
183                 tr '\n' '\0' | lfs_migrate
184         fi
185 else
186         while [ "$1" ]; do
187                 if [ -d "$1" ]; then
188                         lfs find "$1" -type f -print0 | lfs_migrate
189                 else
190                         echo -en "$1\0" | lfs_migrate
191                 fi
192                 shift
193         done
194 fi